package config

import (
	"git.gocasts.ir/ebhomengo/niki/adapter/redis"
	smsprovider "git.gocasts.ir/ebhomengo/niki/adapter/sms_provider"
	"git.gocasts.ir/ebhomengo/niki/repository/mysql"
	authservice "git.gocasts.ir/ebhomengo/niki/service/auth/benefactor"
	benefactorservice "git.gocasts.ir/ebhomengo/niki/service/benefactor/benefactor"
)

type HTTPServer struct {
	Port int `koanf:"port"`
}

type Config struct {
	HTTPServer    HTTPServer               `koanf:"http_server"`
	Mysql         mysql.Config             `koanf:"mysql"`
	Auth          authservice.Config       `koanf:"auth"`
	Redis         redis.Config             `koanf:"redis"`
	SmsProvider   smsprovider.Config       `koanf:"sms_provider"`
	BenefactorSvc benefactorservice.Config `koanf:"benefactor_service"`
}
